CREATE OR REPLACE TRIGGER USR_EXCLUSAO_MOV_ESTOQUE
AFTER DELETE ON LANCTOESTOQ FOR EACH ROW
DECLARE
   V_DTGRV        DATE;
   V_HRGRV        VARCHAR2(04);
   V_NOVOCODIGO    INTEGER;
   V_FILIAL        VARCHAR2(10);
BEGIN
   IF ((:OLD.IDTPLANCTO = '1') OR (:OLD.IDTPLANCTO = '3') OR (:OLD.IDTPLANCTO = '4')) THEN
      V_DTGRV := NULL;
      V_HRGRV := NULL;

      /* Retorna data e hora de exportao */
      BEGIN
         SELECT TO_DATE(SYSDATE), TO_CHAR(SYSDATE,'HH24MI')
           INTO V_DTGRV, V_HRGRV
           FROM DUAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DTGRV := NULL;
            V_HRGRV := NULL;
      END;

      SELECT MAX(CDGRUPFILI)
        INTO V_FILIAL
        FROM FILGRUPFILI
       WHERE CDFILIAL = :OLD.CDFILIMOVI
         AND USR_IDPROTHEUS = 'S';

      FOR C_WG IN (SELECT NVL(MAX(WG_IDMVEST),0) AS WG_IDMVEST,
                          MAX(WG_TPEDI) AS WG_TPEDI, WG_COD
                     FROM USR_ZWG
                    WHERE CDFILIAL = :OLD.CDFILIAL
                      AND NRLANCESTQ = :OLD.NRLANCESTQ
                    GROUP BY WG_COD) LOOP

         IF (NOT V_FILIAL IS NULL) AND (C_WG.WG_TPEDI = '1') THEN

            FOR C_USR_ZWG IN (
               SELECT CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                      WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                      WG_LOTECTL, WG_NUMLOTE, WG_DTVALID
                 FROM USR_ZWG
                WHERE CDFILIAL = :OLD.CDFILIAL
                  AND NRLANCESTQ = :OLD.NRLANCESTQ
                  AND WG_IDMVEST = C_WG.WG_IDMVEST) LOOP

               /* Retorna o sequencial para a tabela */
               BEGIN
                  SELECT WG_IDMVEST.NEXTVAL
                    INTO V_NOVOCODIGO
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_NOVOCODIGO := 1;
               END;

               INSERT INTO USR_ZWG
                  (WG_IDMVEST, CDFILIAL, NRLANCESTQ, WG_EMPRESA, WG_FILIAL, WG_TM, WG_COD, WG_LOCAL, WG_QUANT,
                   WG_EMISSAO, WG_CC, WG_CUSTO, WG_DOC, WG_USUARIO, WG_CONTA, WG_ITEMCTA, WG_CLVL,
                   WG_LOTECTL, WG_NUMLOTE, WG_DTVALID, WG_TPEDI, WG_DTGRV, WG_HRGRV)
               VALUES
                  (V_NOVOCODIGO, C_USR_ZWG.CDFILIAL, C_USR_ZWG.NRLANCESTQ, C_USR_ZWG.WG_EMPRESA, C_USR_ZWG.WG_FILIAL, C_USR_ZWG.WG_TM, C_USR_ZWG.WG_COD, C_USR_ZWG.WG_LOCAL, C_USR_ZWG.WG_QUANT,
                   C_USR_ZWG.WG_EMISSAO, C_USR_ZWG.WG_CC, C_USR_ZWG.WG_CUSTO, C_USR_ZWG.WG_DOC, C_USR_ZWG.WG_USUARIO, C_USR_ZWG.WG_CONTA, C_USR_ZWG.WG_ITEMCTA, C_USR_ZWG.WG_CLVL,
                   C_USR_ZWG.WG_LOTECTL, C_USR_ZWG.WG_NUMLOTE, C_USR_ZWG.WG_DTVALID, '2', V_DTGRV, V_HRGRV);
            END LOOP;
         END IF;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_EXCLUSAO_MOV_ESTOQUE','5.09.000'); END;
/
